//: Render a bicubic quad patch
/*
 
 This will use sixteen control points.
 
 p00    p01   p02   p03
 p10    p11   p12   p13
 p20    p21   p22   p23
 p30    p31   p32   p33
 
 Changes of this from the previous:
 
 16 Control points
 bicubic interpolation in the shader
 number of control points in Renderer and the vertex shader
 */



import Cocoa
import MetalKit
import PlaygroundSupport

// Setup Metal
let device = MTLCreateSystemDefaultDevice()!
let queue = device.makeCommandQueue()!
let frame = NSRect(x: 0, y: 0, width: 600, height: 600)
let metalView = MetalView(frame: frame, device: device)

let renderer = Renderer(device: device)
// change these to up the tessellation
renderer.edgeFactor = [32]
renderer.insideFactor = [32]

metalView.delegate = renderer



PlaygroundPage.current.liveView = metalView




