//: Render a biquadratic quad patch
/*
 
   This will use nine control points.
 
   p00    p01   p02
   p10    p11   p12
   p20    p21   p22
 
 Changes of this from the previous:
 
 Control points
 edge and inside factors
 biquadratic interpolation in the shader
 number of control points in Renderer and the vertex shader
 */



import Cocoa
import MetalKit
import PlaygroundSupport

// Setup Metal
let device = MTLCreateSystemDefaultDevice()!
let queue = device.makeCommandQueue()!
let frame = NSRect(x: 0, y: 0, width: 600, height: 600)
let metalView = MetalView(frame: frame, device: device)

let renderer = Renderer(device: device)
// change these to up the tessellation
renderer.edgeFactor = [24]
renderer.insideFactor = [24]

metalView.delegate = renderer



PlaygroundPage.current.liveView = metalView



