import MetalKit

public class MetalView: MTKView {
  
  public override init(frame frameRect: CGRect, device: MTLDevice?) {
    super.init(frame: frameRect, device: device)
    let pan = NSPanGestureRecognizer(target: self, action: #selector(handlePan(gesture:)))
    addGestureRecognizer(pan)
  }
  
  public required init(coder: NSCoder) {
    fatalError("init(coder:) has not been implemented")
  }
  
  @objc public func handlePan(gesture: NSPanGestureRecognizer) {
    let translation = gesture.translation(in: self)
    if let renderer = delegate as? Renderer {
      renderer.rotateUsing(translation: translation)
    }
    gesture.setTranslation(.zero, in: self)
  }
}
