#include <metal_stdlib>
using namespace metal;

struct ModelConstants {
  float4x4 modelViewMatrix;
};

struct VertexIn {
  float4 position [[ attribute(0) ]];
  float4 color [[ attribute(1) ]];
  float2 textureCoordinates [[ attribute(2) ]];
};

struct VertexOut {
  float4 position [[ position ]];
  float4 color;
  float2 textureCoordinates;
};


vertex VertexOut vertex_shader(const VertexIn vertexIn [[ stage_in ]],
                               constant ModelConstants &modelConstants [[ buffer(1) ]])  {
  VertexOut vertexOut;
  vertexOut.position = modelConstants.modelViewMatrix * vertexIn.position;
  vertexOut.color = vertexIn.color;
  vertexOut.textureCoordinates = vertexIn.textureCoordinates;
  return vertexOut;
}

fragment half4 fragment_shader(VertexOut fragmentIn [[ stage_in ]]) {
  return half4(fragmentIn.color);
}



