
import simd

public struct Vertex {
  var position: float3
  var color: float4
  var texture: float2
}

// Thank you Philip Rideout
// http://prideout.net/blog/?p=48

public var vertices = [
  Vertex(position: float3(0, 0, 1),
    color: float4(1.0, 0.0, 0.0, 1.0),
    texture: float2(0 ,0)),
  Vertex(position: float3(0.894, 0, 0.447),
    color:    float4(0, 1, 0, 1),
    texture:  float2(0, 1)),
  Vertex(position: float3(0.276, 0.851, 0.447),
    color:    float4(0, 0, 1, 1),
    texture:  float2(1, 1)),
  Vertex(position: float3(-0.724, 0.526, 0.447),
    color:    float4(1, 0, 1, 1),
    texture:  float2(1, 0)),
  
  Vertex(position: float3(-0.724, -0.526, 0.447),
    color:    float4(0, 0, 1, 1),
    texture:  float2(1, 1)),
  Vertex(position: float3(0.276, -0.851, 0.447),
    color:    float4(0, 1, 0, 1),
    texture:  float2(0, 1)),
  Vertex(position: float3(0.724, 0.526, -0.447),
    color:    float4(1, 0, 0, 1),
    texture:  float2(0, 0)),
  Vertex(position: float3(-0.276, 0.851, -0.447),
    color:    float4(1, 0, 0, 1),
    texture:  float2(0, 0)),
  Vertex(position: float3(-0.894, 0, -0.447),
    color:    float4(1, 0, 0, 1),
    texture:  float2(0, 0)),
  Vertex(position: float3(-0.276, -0.851, -0.447),
    color:    float4(1, 0, 0, 1),
    texture:  float2(0, 0)),
  Vertex(position: float3(0.724, -0.526, -0.447),
    color:    float4(1, 0, 0, 1),
    texture:  float2(0, 0)),
  Vertex(position: float3(0, 0, -1),
    color:    float4(1, 0, 1, 1),
    texture:  float2(1, 0)),
]

let indices: [UInt16] = [
  2, 1, 0,     3, 2, 0,
  4, 3, 0,     5, 4, 0,
  
  1, 5, 0,     11, 6, 7,
  11, 7, 8,     11, 8, 9,
  
  11, 9, 10,     11, 10, 6,
  1, 2, 6,     2, 3, 7,
  3, 4, 8,     4, 5, 9,
  5, 1, 10,     2, 7, 6,
  3, 8, 7,     4, 9, 8,
  
  5, 10, 9,     1, 6, 10
]
