//: Create a tessellated sphere parametrically

/* parametric equation of a sphere is:

 (xyz) = r * sinphi * costheta * sinphi * sintheta, r * cosphi
 where r is the radius of the sphere and phi = [0..π]
 and theta = [0..2π]
*/


import Cocoa
import MetalKit
import PlaygroundSupport

// Setup Metal
let device = MTLCreateSystemDefaultDevice()!
let queue = device.makeCommandQueue()!
let frame = NSRect(x: 0, y: 0, width: 600, height: 600)
let metalView = MetalView(frame: frame, device: device)

let renderer = Renderer(device: device)
// change these to up the tessellation
renderer.edgeFactor = [32]
renderer.insideFactor = [32]

metalView.delegate = renderer



PlaygroundPage.current.liveView = metalView





