//: Create a tessellated torus parametrically

/* parametric equation of a sphere is:
 
 x = (c + r * costheta) * cosphi
 y = (c + r * costheta) * sinphi
 z = r * sintheta
 where r is the radius of the tube
 and c is the distance from the center
 and phi = [0..2π]
 and theta = [0..4π]
 */


import Cocoa
import MetalKit
import PlaygroundSupport

// Setup Metal
let device = MTLCreateSystemDefaultDevice()!
let queue = device.makeCommandQueue()!
let frame = NSRect(x: 0, y: 0, width: 600, height: 600)
let metalView = MetalView(frame: frame, device: device)

let renderer = Renderer(device: device)
// change these to up the tessellation
renderer.edgeFactor = [32]
renderer.insideFactor = [32]

metalView.delegate = renderer



PlaygroundPage.current.liveView = metalView






