//: K3DSurf also known as MathMod

/*
 Download K3DSurf here: https://sourceforge.net/projects/k3dsurf/
 K3DSurf is a program to visualize and manipulate Mathematical models in three, four, five and six dimensions. K3DSurf supports Parametric equations and Isosurfaces.
 
 There are two shaders to try -
 change the vertex function in Renderer
 tessellation_horn
 tessellation_apple
 */


import Cocoa
import MetalKit
import PlaygroundSupport

// Setup Metal
let device = MTLCreateSystemDefaultDevice()!
let queue = device.makeCommandQueue()!
let frame = NSRect(x: 0, y: 0, width: 600, height: 600)
let metalView = MetalView(frame: frame, device: device)

let renderer = Renderer(device: device)
// change these to up the tessellation
renderer.edgeFactor = [32]
renderer.insideFactor = [32]

metalView.delegate = renderer



PlaygroundPage.current.liveView = metalView







